#include <stdio.h>
#include <stdlib.h>
#include <wchar.h>
#include <locale.h>

#define A 256

struct node {
  wchar_t lettre;
  struct cell* listeFils; //Accés cellule contenant une des lettres suivante à "lettre"
};

struct cell {
  struct node* arbre;
  struct cell* arbreSuivant; //Accés à la cellule contenant une autre lettre suivante à "lettre"
};

void lien_listeFils(struct cell** pL) {
  struct cell* p;
  p = malloc(sizeof(struct cell));
 
  (*pL)->arbre->listeFils = p;
}

void initialisation_tab_arbre(struct node tab[]) {
  int i = 0;
  for(wchar_t u = 'a'; u < A; u++) {
    tab[i].lettre = u; //ajout lettres minuscules
    tab[i].listeFils = NULL;
    i++;
  }
}

void ajout_tete(wchar_t elem, struct cell** pL) {
  struct cell* p;
  p = malloc(sizeof(struct cell));
  p->arbre = malloc(sizeof(struct node));
  p->arbre->listeFils = NULL;
  p->arbre->lettre = elem;
  p->arbreSuivant = *pL;
  *pL = p;
}

struct cell ** insertion(wchar_t elem, struct cell** pL) {
	if(((*pL) == NULL) || ((*pL)->arbre->lettre > elem)) {
		ajout_tete(elem, pL);
		return &(*pL)->arbre->listeFils;
	}
	else if((*pL)->arbre->lettre == elem) {
		return &(*pL)->arbre->listeFils;
	}
	else {
		return insertion(elem, &(*pL)->arbreSuivant);
	}
}

int indice_lettre(struct node tab_arbre_prcp[], wchar_t lettre)
{
  int i = 1;
  while(i > 0 && i < A){  
   if(lettre == tab_arbre_prcp[i].lettre ){
     return i;
   }  
   i++;
  }
return 0;
}

void remplir_dico(FILE* fd, struct node tab_arbre_prcp[]) {

  struct cell** localisationArbre = NULL; 
  int cptmot = 0, indice = 0;
  wchar_t motLu[50];
  while(fwscanf(fd, L"%ls", motLu)==1) {
  	wprintf(L"mot lu : %ls\n", motLu);
  	int estUneLettre = 1;
	int i = 0;
    cptmot += 1;
     if((motLu[0] >= 'A') && (motLu[0] <= 'Z')) {
       localisationArbre = &tab_arbre_prcp[motLu[0]-65].listeFils;
     }
     else if((motLu[0] >= 'a') && (motLu[0] <= 'z')) {
       localisationArbre = &tab_arbre_prcp[motLu[0]-97].listeFils;
     }
     else if(motLu[0] > 'z') {
       indice = indice_lettre(tab_arbre_prcp, motLu[0]);
       localisationArbre = &tab_arbre_prcp[indice].listeFils;
       if(indice == 0) {
	 	wprintf(L"Erreur remplissage dico : L'un des caracteres n'est pas une lettre\n");
		wprintf(L"Mot : %ls incorrect\n", motLu);
	 	estUneLettre = 0;
       }
     }
     else {
       wprintf(L"Erreur remplissage dico : L'un des caracteres n'est pas une lettre\n");
       wprintf(L"Mot : %ls incorrect\n", motLu);
       estUneLettre = 0;
     }
     while((motLu[i] != '\0') && (estUneLettre == 1)) {
  	i += 1;
  	wprintf(L"lettre lue %d\n", motLu[i]);
	localisationArbre = insertion(motLu[i], localisationArbre);
     }
   }
	wprintf(L"\n");
	fclose(fd);
  	wprintf(L"%d mots inseres dans le dictionnaire.\n", cptmot);
}

struct cell** test_mot(wchar_t mot, struct cell** localisation, int* verif) {

  if((*localisation == NULL) || (*localisation)->arbre->lettre > mot) {
    *verif = 0;
    return NULL;
  }
  if((*localisation)->arbre->lettre == mot) {
    return &(*localisation)->arbre->listeFils;
  }
  else {
    return test_mot(mot, &(*localisation)->arbreSuivant, verif);
  }
}

void correction_txt(FILE* fd, struct node tab_arbre_prcp[]) {
  struct cell** localisationArbre = NULL;
  int verif;
  int indice = 0;
  wchar_t motLu[50];
  while(fwscanf(fd, L"%ls", motLu)==1) {
      verif = 1;
      int i = 0;
      if((motLu[0] >= 'A') && (motLu[0] <= 'Z')) {
        localisationArbre = &tab_arbre_prcp[motLu[0]-65].listeFils;
      }
      else if((motLu[0] >= 'a') && (motLu[0] <= 'z')) {
        localisationArbre = &tab_arbre_prcp[motLu[0]-97].listeFils;
      }
      else if(motLu[0] > 'z') {
       indice = indice_lettre(tab_arbre_prcp, motLu[0]);
       localisationArbre = &tab_arbre_prcp[indice].listeFils;
       if(indice == 0) {
	wprintf(L"Erreur correction txt : L'un des caracteres n'est pas une lettre\n");
        verif = 0;
       }
      }
      else {
        wprintf(L"Erreur correction txt : L'un des caracteres n'est pas une lettre\n");
        verif = 0;
      }
      while((verif == 1) && (motLu[i] != '\0')) {
        i += 1;
        localisationArbre = test_mot(motLu[i], localisationArbre, &verif);
      }
      if(verif == 0) wprintf(L"Mot %ls non present dans le dicitonnaire.\n", motLu);
    }
    fclose(fd);
} 

void correction_mot(struct node tab_arbre_prcp[]) {
  struct cell** localisationArbre = NULL;
  int verif;
  int indice = 0;
  wchar_t motLu[50];
  wprintf(L"Entrez un mot ou une phrase a corriger : \n(0 pour quitter)\n");
  while(wscanf(L"%ls", motLu)==1) {
      if(motLu[0]=='0') return;
      verif = 1;
      int i = 0;
      if((motLu[0] >= 'A') && (motLu[0] <= 'Z')) {
        localisationArbre = &tab_arbre_prcp[motLu[0]-65].listeFils;
      }
      else if((motLu[0] >= 'a') && (motLu[0] <= 'z')) {
        localisationArbre = &tab_arbre_prcp[motLu[0]-97].listeFils;
      }
      else if(motLu[0] > 'z') {
       indice = indice_lettre(tab_arbre_prcp, motLu[0]);
       localisationArbre = &tab_arbre_prcp[indice].listeFils;
       if(indice == 0) {
	wprintf(L"Erreur correction mot : L'un des caracteres n'est pas une lettre\n");
        verif = 0;
       }
      }
      else {
        wprintf(L"Erreur correction mot : L'un des caracteres n'est pas une lettre\n");
        verif = 0;
      }
      while((verif == 1) && (motLu[i] != '\0')) {
        i += 1;
        wprintf(L"lettre lue %d\n", motLu[i]);
        localisationArbre = test_mot(motLu[i], localisationArbre, &verif);
      }
      if(verif == 0) wprintf(L"Mot : %ls non present dans le dicitonnaire.\n", motLu);
      else wprintf(L"Mot : %ls correct\n", motLu);
    }
} 

/*void supp_tete(struct cell** pL) {
  struct cell* p;
  p = *pL;
  *pL = (*pL) -> arbreSuivant;
  free(p);
}*/

void desalocation(struct node** pL) {
  if ((*pL) -> listeFils == NULL) return;
  if ((*pL) -> listeFils -> arbreSuivant != NULL) desalocation(&(*pL) -> listeFils -> arbreSuivant -> arbre);
  desalocation(&(*pL) -> listeFils -> arbre);
  free((*pL) -> listeFils);
  free(*pL); 
}

<<<<<<< HEAD
=======
void desalocation(struct node* arbre) {
	if(arbre == NULL) return;
	struct cell* listeFils2 = arbre->listeFils;
	while(listeFils2 != NULL) {
		listeFils2 = arbre->listeFils;
	}
	while(listeFils2->arbreSuivant != NULL) {
		supp_tete(&listeFils2->arbreSuivant);
	}
}

>>>>>>> a8b3b5881e89dd7ae93a7b952fda31f1b524325b
int main(int argc, char* argv[]) {

 int i =0;
  setlocale(LC_ALL, "");
  FILE* dico = NULL;
  FILE* txt = NULL;
  struct node tab_arbre[A];
  struct node * a;
  
  if(argc>2) {
    dico = fopen(argv[1], "r");
    txt = fopen(argv[2], "r");
  }
  else {
    dico = NULL;
    txt = NULL;
  }
  if ((dico == NULL) || (txt == NULL)) {
        wprintf(L"Erreur : il manque un ou plusieurs fichiers !\n");
        return 1;
    }
  initialisation_tab_arbre(tab_arbre);
  remplir_dico(dico, tab_arbre); //on suppose qu'il n'y a pas d'accents dans le dictionnaire
  correction_txt(txt, tab_arbre);
  correction_mot(tab_arbre);
<<<<<<< HEAD
  for(wchar_t u = 'a'; u < A; u++) {
    a=&tab_arbre[i];
    desalocation(&a);
    i++;
  }
  

=======
  printf("tab_arbre[0].lettre : %c\n", tab_arbre[0].lettre);
  printf("tab_arbre[0].listeFils : %p\n", tab_arbre[0].listeFils);
  printf("tab_arbre[0].listeFils->arbre : %p\n", tab_arbre[0].listeFils->arbre);
  printf("tab_arbre[0].listeFils->arbre->lettre : %c\n", tab_arbre[0].listeFils->arbre->lettre);
  printf("tab_arbre[0].listeFils->arbre->listeFils->arbre->lettre : %c\n", tab_arbre[0].listeFils->arbre->listeFils->arbre->lettre);
  printf("tab_arbre[0].listeFils->arbre->listeFils->arbre->listeFils->arbre->lettre : %c\n", tab_arbre[0].listeFils->arbre->listeFils->arbre->listeFils->arbre->lettre);
  printf("tab_arbre[0].listeFils->arbreSuivant->arbre->lettre : %c\n", tab_arbre[0].listeFils->arbreSuivant->arbre->lettre);
>>>>>>> a8b3b5881e89dd7ae93a7b952fda31f1b524325b
  return 0;
}
